#include "parallel.h"

#define DEBUG_Factorization

void Factorization(Dlu_info *Info, Cvector *b, Cvector *x, Extra *extra)
{
   char *Subroutine_name = "Factorization():";
   int  *Matrix_Rank = &(Info->rank);
   int   Matrix_Size = Info->Matrix->M;

   if(!(Info -> fact_mode))
   {
#ifdef DEBUG_Factorization
      print("Factorization(): calling 'A' mode");
#endif
      lu_factor_Dmatrix_a(Info, NULL, b);
      Info -> fact_mode = 1;
   }
   else
   {
#ifdef DEBUG_Factorization
      print("Factorization(): calling 'B' mode");
#endif
      lu_factor_Dmatrix_b(Info, NULL, b);
   }


   if (*Matrix_Rank < Matrix_Size)
   {
      /*
       * this condition will appear in all proc. columns so no recursive
       * doubling is required...
       */

      print("%s Jacobian rank deficient with rank %d < %d",
            Subroutine_name, *Matrix_Rank, Matrix_Size);
      exit(1);
   }
   else
   {
      if ((b != NULL) && (x != NULL))
      {
         back_solve_lu_Dmatrix(Info, NULL, 0, b, x);
      }
   }

#ifdef DEBUG_Factorization
   print("Factorization() exiting");
#endif
}

void Solve(Dlu_info *Info, Cvector *b, Cvector *x, Extra *extra)
{
   char *Subroutine_name = "Solve():";

   solve_lu_Dmatrix(Info, b, x);
}
